<template>
  <div class="columns">
    <div class="column border-right">
      <h2 class="title is-2">Register</h2>

      <form @submit.prevent="add">
        <div class="box">
          <label>
            Username:
            <br />
            <input class="input" type="text" v-model="form.name" />
          </label>

          <label>
            Password:
            <br />
            <input class="input" type="password" v-model="form.password" />
          </label>
        </div>

        <input class="button is-link" type="submit" value="Register" />
      </form>
    </div>
    <div class="column">
      <h2 class="title is-2">Register</h2>

      <form @submit.prevent="addReal">
        <div class="box">
          <label>
            Username:
            <br />
            <input class="input" type="text" v-model="form.name" />
          </label>

          <label>
            Password:
            <br />
            <input class="input" type="password" v-model="form.password" @input="validatePassword" />
            <span
              class="error hidden"
            >Requires at least one lower Case, uper Case numeric Letter, one special Character and must have a length of 8 Characters</span>
            <span
              class="errorPassword hidden"
            >The used Password is banned, please use a other password</span>
          </label>
        </div>

        <input class="button is-link" type="submit" value="Register" />
      </form>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "register",
  data() {
    return {
      form: {
        name: "",
        password: ""
      },
      error: null
    };
  },
  methods: {
    validatePassword(e) {
      var errorText = document.getElementsByClassName("error")[0]
      var strongRegex = new RegExp("^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.*[!@#\$%\^&\*])(?=.{8,})");
      if (e.target.value.match(strongRegex) !== null) {
        errorText.classList.add("hidden");
      } else {
        errorText.classList.remove("hidden");
      }
    },
    add() {
      axios.post(`/api/auth/register`, this.$data.form).then(res => {
        this.$router.push("/login");
      });
    },
    addReal() {
      var errorText = document.getElementsByClassName("error")[0];
      if (errorText.classList.contains("hidden")) {
        axios.post(`/api/real/auth/register`, this.$data.form).then(res => {
          this.$router.push("/login");
        }).catch(error => {
          document.getElementsByClassName("errorPassword")[0].classList.remove("hidden");
        });
      }
    }
  }
};
</script>